import 'package:flutter/material.dart';
import 'package:progamification/src/components/achievements.dart';
import 'package:progamification/src/components/leaderboard_table.dart';

class LeaderboardInfo extends StatefulWidget {
  const LeaderboardInfo({super.key});

  @override
  State<LeaderboardInfo> createState() => _LeaderboardInfoState();
}

class _LeaderboardInfoState extends State<LeaderboardInfo>
    with SingleTickerProviderStateMixin {
  late TabController _controller;
  @override
  void initState() {
    super.initState();
    _controller = TabController(
      initialIndex: 0,
      length: 2,
      vsync: this,
    );
  }

  @override
  Widget build(BuildContext context) {
    return SizedBox(
        height: MediaQuery.of(context).size.height * 0.8,
        child: SingleChildScrollView(
            child: Column(
          children: [
            Container(
              decoration: const BoxDecoration(color: Colors.white),
              child: TabBar(
                indicatorColor: Colors.black,
                indicatorSize: TabBarIndicatorSize.tab,
                indicatorWeight: 3.0,
                controller: _controller,
                tabs: const [
                  Padding(
                    padding: EdgeInsets.all(2.0),
                    child: Tab(
                      child: FittedBox(
                        fit: BoxFit.fitWidth,
                        child: Text(
                          "Achievements",
                          style: TextStyle(
                              color: Colors.black,
                              fontSize: 16,
                              fontFamily: 'Roboto',
                              letterSpacing: 0.5,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                    ),
                  ),
                  Padding(
                    padding: EdgeInsets.all(2.0),
                    child: Tab(
                      child: FittedBox(
                        fit: BoxFit.fitWidth,
                        child: Text(
                          "Leaderboard",
                          style: TextStyle(
                              color: Colors.black,
                              fontSize: 16,
                              fontFamily: 'Roboto',
                              letterSpacing: 1,
                              fontWeight: FontWeight.bold),
                        ),
                      ),
                    ),
                  ),
                ],
              ),
            ),
            SizedBox(
              height: MediaQuery.of(context).size.height * 0.8,
              child: TabBarView(
                controller: _controller,
                children: const [
                  Achievements(),
                  LeaderBoardTable(),
                ],
              ),
            ),
          ],
        )));
  }
}
