import 'package:flutter/material.dart';
import 'package:progamification/src/controllers/leader_board.dart';
import 'package:get/get.dart';
import 'package:progamification/src/services/sas_token.service.dart';

class Progress extends StatefulWidget {
  const Progress({super.key});

  @override
  State<Progress> createState() => _ProgressState();
}

class _ProgressState extends State<Progress> {
  LeaderBoardController leaderBoardController =
      Get.find<LeaderBoardController>();

  SasTokenService sasTokenService = Get.find<SasTokenService>();
  String sasToken = "";

  @override
  initState() {
    super.initState();
    sasTokenService.getSasToken().then((value) {
      setState(() {
        sasToken = value.toString();
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Padding(
      padding: const EdgeInsets.only(
          left: 16.0, right: 16.0, top: 16.0, bottom: 8.0),
      child: Row(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Padding(
            padding: const EdgeInsets.all(2),
            child: Container(
              width: 42.0,
              height: 42.0,
              decoration: BoxDecoration(
                shape: BoxShape.circle,
                border: Border.all(
                  color: Colors.blue,
                  width: 2.5,
                ),
              ),
              child: ClipOval(
                child: Image.network(
                    ('${leaderBoardController.userRewards["previousReward"]?["sourceImgUrl"]}${sasToken}'),
                    fit: BoxFit.cover,
                    errorBuilder: (context, child, loadingProgress) => SizedBox(
                        width: 48.0,
                        height: 48.0,
                        child: Image.asset('assets/icons/no-reward.png',
                            package: 'progamification'))),
              ),
            ),
          ),
          Expanded(
            child: Tooltip(
                message:
                    '${int.parse(leaderBoardController.userRewards["progress"]) / 100}% completed',
                child: LinearProgressIndicator(
                  backgroundColor: const Color(0xFFe8ecf8),
                  color: Colors.blue,
                  value:
                      int.parse(leaderBoardController.userRewards["progress"]) /
                          100,
                  minHeight: 6,
                )),
          ),
          Padding(
            padding: const EdgeInsets.all(2),
            child: Container(
              width: 42.0,
              height: 42.0,
              decoration: BoxDecoration(
                shape: BoxShape.circle,
                border: Border.all(
                  color: Colors.blue,
                  width: 2.5,
                ),
              ),
              child: ClipOval(
                child: Image.network(
                    ('${leaderBoardController.userRewards["nextReward"]?["sourceImgUrl"]}${sasToken}'),
                    fit: BoxFit.cover,
                    errorBuilder: (context, child, loadingProgress) => SizedBox(
                        width: 48.0,
                        height: 48.0,
                        child: Image.asset('assets/icons/no-reward.png',
                            package: 'progamification'))),
              ),
            ),
          ),
        ],
      ),
    );
  }
}
