import 'package:dio/dio.dart';
import 'package:progamification/src/constants/service_urls.dart';
import 'package:progamification/src/models/user.dart';

import '../utilities/http_client.dart';

class UserService {
  var httpClient = getHttpClient();

  Future<Response> getUserInformation(String userId, String applicationId) {
    return httpClient.get(ServiceUrls.getUserById(userId, applicationId));
  }

  Future<Response> addPointsToUser(Map<String, dynamic> triggerGameAction) {
    return httpClient.post(ServiceUrls.updateGameAction,
        data: triggerGameAction);
  }

  Future<Response> addUser(GamifiedUser user) {
    return httpClient.post(ServiceUrls.createUser, data: user);
  }

  Future<Response> updateUser(
      String userId, String applicationId, GamifiedUser user) {
    return httpClient.put(ServiceUrls.updateUser(userId, applicationId),
        data: user);
  }

  Future<Response> getPrivilegeStageInfo(String applicationId) {
    return httpClient.get(ServiceUrls.getAllPrivilegeStages(applicationId));
  }
}
